package be.iminds.ilabt.jfed.experimenter_gui.controller.controller.action;

import be.iminds.ilabt.jfed.experimenter_gui.controller.model.ControllerModel;
import be.iminds.ilabt.jfed.experimenter_gui.controller.util.TimeCoordinateTranslator;
import be.iminds.ilabt.jfed.experimenter_gui.controller.view.IControllerComponent;
import be.iminds.ilabt.jfed.experimenter_gui.controller.view.UpdateEvent;

/**
 *
 * @author Cedric
 */
public class ResetZoomAction implements IAction{
    private double zoom;
    
    @Override
    public boolean execute(ControllerModel model, IControllerComponent view) {
        TimeCoordinateTranslator tct = TimeCoordinateTranslator.getInstance();
        
        zoom = tct.getZoom();
        
        tct.resetZoom();
        view.update(UpdateEvent.UPDATE_ZOOM, null);
        return true;
    }

    @Override
    public boolean undo(ControllerModel model, IControllerComponent view) {
        TimeCoordinateTranslator tct = TimeCoordinateTranslator.getInstance();
        tct.setZoom(zoom);
        view.update(UpdateEvent.UPDATE_ZOOM, null);
        return true;
    }
    
}
